<?php
	if (count($_POST) > 0) {
		include('add_link.php');
	}
	// include this at the very top of index.php
	// open the links file and insert into array
	$links_file = file( 'links.txt' );

	// loop through the file, line by line
	foreach ($links_file as $line ) {
		$line = rtrim( $line );
		$field = explode( "\t", $line );
		// make sure a category and link exist
		if ( $field[0] && $field[1] ) {
		  // set the description to the link if absent
		  if ( !$field[2] ) {
		    $field[2] = $field[1];
		  }
		  // push each link into a hash of each category - this creates
		  // a multidimensional associative array called $links_hash
		  $field[2] = stripslashes($field[2]);
		  $links_hash["$field[0]"][]="<a href=\"$field[1]\">$field[2]</a>";
		}
	}
	// sort the hash by the key ("category")
	ksort ( $links_hash );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>Links Project</title>
</head>

<body>
<form action="<?php echo $_SERVER[PHP_SELF]; ?>" method="post">
	Url: <input type="text" name="url" /><br />
	Category: <input type="text" name="category" /><br />
	Description: <input type="text" name="description" /><br />
	<input type="submit" />
</form>
<div id="categories">
<?php
	// place this in the body of index.php
	// Display the Categories as links to anchors
	echo( "<b>Categories:</b><br />\n" );
	while ( list($key,$value) = each($links_hash) ) {
		echo( "<a href=\"#$key\">$key</a><br />\n" );
	}
	reset( $links_hash );
?>
</div>
<div id="links">
<?
  // add to body of index.php
  echo( "<br /><b>Links:</b><br />\n" );
  while( list($key, $value) = each ($links_hash) ) {
    echo( "<p><a href=\"#top\" name=\"$key\"><b>$key</b></a><br />\n" );
    sort ( $value );
    for ( $i=0; $i < count($value); ++$i ) {
      echo( "$value[$i]<br />\n" );
    }
  }
?>
</div>
</body>
</html>