<?
    // File: process_link.php 
    // Author: John Keston
    // Description: Drop/add/edit a link from the the links flat file
	function checkURLandConnect($url) {  
		if (!preg_match ("/http:\/\/(.*)\.(.*)/i", $url)) {
			return 0;
		}
		$parts = parse_url($url);
		$fp = @fsockopen($parts['host'], 80, $errno, $errstr, 10);
		if(!$fp) {
			return 1;
		}
		fclose($fp);
		return 2;
	}
	
	date_default_timezone_set("America/Chicago");
	// decide what to do and do it 
	switch($_POST[task]) {
	case "delete":
		$message = "Link not found"; 
		if ( $_POST[edit_url] ) {
			$links_file = file ( 'links.txt' );
			foreach( $links_file as $line ) {
				$field = explode( "\t", $line );
				if ( rtrim($field[1]) == $_POST[edit_url] ) {
					$message = "Link deleted";
				}
				else {
					$new_file[] = $line;
				}
				// Uncomment this line for troubleshooting
				// echo ( "<pre>|$_POST[drop_url]|$field[1]|$field[2]|\n" );
			}
			$new_links = fopen( 'links.txt', "w+" );
			foreach( $new_file as $link ) {
				fwrite( $new_links, $link );
			}
			fclose( $new_links );
		}
		header( "Location: index.php?message=$message" );
		exit();
		break;
	case "edit":
		switch ( checkURLandConnect($_POST[edit_url]) ) {
			case 0:
				header("Location: index.php?message=Invalid URL. Please try again.");
				exit;
			case 1:
				header("Location: index.php?message=Could not connect to $_POST[url].");
				exit;
			case 2:
				break;
		}
		// Make sure $url and $category exist before editing
		if ( $_POST[edit_url] && $_POST[edit_desc] && $_POST[edit_tags] ) {
			$links_file = file ( 'links.txt' );
			foreach ( $links_file as $line ) {
				$field = explode( "\t", $line );
				$match = rtrim( $field[1] );
				// Find link to edit links
				if ( $match != $_POST[orig_url] ) {
					$new_lines[] = $line;
				}
			}
			foreach( $new_lines as $line ) {
				$field = explode( "\t", $line );
				$match = rtrim( $field[1] );
				// Check for duplicate links
				if ( $match == $_POST[edit_url] ) {
					header( "Location: index.php?message=Duplicate Link" );
					exit( );
				}
			}
			reset( $new_lines );
			$links_file = fopen( 'links.txt', "w+" );
			$tag_list = explode(",", $_POST[edit_tags]);
			$new_link = date('Y-m-d H:m:s')."\t$_POST[edit_url]\t$_POST[edit_desc]";
			foreach( $tag_list as $tag ) {
				$new_link .= "\t".trim($tag);
			}
			$new_link .= "\n";
			foreach( $new_lines as $line ) {
				fwrite( $links_file, $line );
			}
			fwrite( $links_file, $new_link );
			fclose( $links_file );
		}
		else {
			header( "Location: index.php?message=Please fill out all fields" );
			exit();
		}
		header( "Location: index.php?message=Link Edited" );
		exit();
		break;
	case "add":
		switch ( checkURLandConnect($_POST[url]) ) {
			case 0:
				header("Location: index.php?message=Invalid URL. Please try again.");
				exit;
			case 1:
				header("Location: index.php?message=Could not connect to $_POST[url].");
				exit;
			case 2:
				break;
		}
		// Make sure $url and $category exist before adding
		if ( $_POST[url] && $_POST[description] && $_POST[tags] ) {
			$links_file = file ( 'links.txt' );
			foreach( $links_file as $line ) {
				$field = explode( "\t", $line );
				$match = rtrim( $field[1] );
				// Check for duplicate links
				if ( $match == $_POST[url] ) {
					header( "Location: index.php?message=Duplicate Link" );
					exit( );
				}
			}
			$links_file = fopen( 'links.txt', "a+" );
			$tag_list = explode(",", $_POST[tags]);
			$new_link = date('Y-m-d H:m:s')."\t$_POST[url]\t$_POST[description]";
			foreach( $tag_list as $tag ) {
				$new_link .= "\t".trim($tag);
			}
			$new_link .= "\n";
			fwrite( $links_file, $new_link );
			fclose( $links_file );
		}
		else {
			header( "Location: index.php?message=Please fill out all fields" );
			exit();
		}
		header( "Location: index.php?message=Link Added" );
		exit();
	default:
		break;
	}
	header( "Location: index.php?message=Task not found" );
	exit();
?>